SystemOrganization addCategory: #'Keymapping-Editors'!

!TextMorph methodsFor: '*Keymapping-Editors-override' stamp: 'GuillermoPolito 12/11/2011 02:15'!
handleKeystroke: anEvent 
	"System level event handling."
	| pasteUp |
	anEvent wasHandled
		ifTrue: [^ self].
	self allowsKeymapping
		ifTrue: [ self dispatchKeystrokeForEvent: anEvent ] .
	anEvent wasHandled
		ifTrue: [^ self].
	(self handlesKeyboard: anEvent)
		ifFalse: [^ self].
	anEvent keyCharacter = Character tab
		ifTrue: ["Allow passing through text morph inside pasteups"
			pasteUp := self pasteUpMorphHandlingTabAmongFields.
			(self wouldAcceptKeyboardFocusUponTab
					and: [(pasteUp) notNil])
				ifTrue: [^ pasteUp tabHitWithEvent: anEvent]].
	self keyStroke: anEvent.
	anEvent wasHandled: true.! !

Object subclass: #KMEditorsDefaultSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Editors'!

!KMEditorsDefaultSettings class methodsFor: 'settings' stamp: 'GuillermoPolito 8/15/2012 18:33'!
buildCtrlTextEditorKeymapsOn: aBuilder
	<keymap: #Windows>
	<keymap: #Unix>
			
	(aBuilder shortcut: #selectAll) 
		category: #TextEditor
		default: $a ctrl
		do: [ :morph | morph handleEdit: [ morph selectAll ] ].
		
	(aBuilder shortcut: #copySelection) 
		category: #TextEditor
		default: $c ctrl
		do: [ :morph | morph copySelection ].
		
	(aBuilder shortcut: #find) 
		category: #TextEditor
		default: $f ctrl
		do: [ :morph | morph find ].
		
	(aBuilder shortcut: #findAgain) 
		category: #TextEditor
		default: $g ctrl
		do: [ :morph | morph findAgain ].
		
	(aBuilder shortcut: #setSearchString)
		category: #TextEditor
		default: $h ctrl
		do: [ :morph | morph setSearchString ].
		
	(aBuilder shortcut: #cancel) 
		category: #TextEditor
		default: $l ctrl
		do: [ :morph | morph cancel ].
		
	(aBuilder shortcut: #paste) 
		category: #TextEditor
		default: $v ctrl
		do: [ :morph | morph paste ].
		
	(aBuilder shortcut: #cut) 
		category: #TextEditor
		default: $x ctrl
		do: [ :morph | morph cut ].
				
	(aBuilder shortcut: #undo) 
		category: #TextEditor
		default: $z ctrl
		do: [ :morph | morph undo ].
		
	(aBuilder shortcut: #redo) 
		category: #TextEditor
		default: $z ctrl shift
		do: [ :morph | morph redo ].
	
	(aBuilder shortcut: #cursorHome)
		category: #TextEditor
		default: Character home ctrl
		do: [ :morph :target :evt | morph cursorHome: evt ].
	
	(aBuilder shortcut: #cursorEnd)
		category: #TextEditor
		default: Character end ctrl
		do: [ :morph :target :evt | morph cursorEnd: evt ].
		
	(aBuilder shortcut: #removeLine)
		category: #TextEditor
		default: Character delete shift
		do: [ :morph | morph removeLine ].! !

!KMEditorsDefaultSettings class methodsFor: 'settings' stamp: 'GuillermoPolito 12/11/2011 03:07'!
buildSmalltalkEditorKeymappingsOn: aBuilder
	<keymap>
	(aBuilder shortcut: #browseIt) 
		category: #SmalltalkEditor
		default: $b command
		do: [ :morph | morph browseIt ].
				
	(aBuilder shortcut: #doIt) 
		category: #SmalltalkEditor
		default: $d command
		do: [ :morph | morph doIt ].
		
	(aBuilder shortcut: #inspectIt) 
		category: #SmalltalkEditor
		default: $i command
		do: [ :morph | morph inspectIt ].
		
	(aBuilder shortcut: #implementorsOfIt) 
		category: #SmalltalkEditor
		default: $m command
		do: [ :morph | morph implementorsOfIt ].
		
	(aBuilder shortcut: #sendersOfIt) 
		category: #SmalltalkEditor
		default: $n command
		do: [ :morph | morph sendersOfIt ].

	(aBuilder shortcut: #printIt) 
		category: #SmalltalkEditor
		default: $p command
		do: [ :morph | morph printIt ].! !

!KMEditorsDefaultSettings class methodsFor: 'settings' stamp: 'GuillermoPolito 12/11/2011 03:12'!
buildSmalltalkEditorSettingsOn: aBuilder
	(aBuilder shortcut: #browseIt) 
		category: #SmalltalkEditor;
		shortcutName: #browseIt;
		label: 'browse it' translated;
 		description: 'editor shortcut to browse a piece of code' translated.
		
	(aBuilder shortcut: #doIt) 
		category: #SmalltalkEditor;
		shortcutName: #doIt;
		label: 'do it' translated;
 		description: 'editor shortcut to evaluate a piece of code' translated.
		
	(aBuilder shortcut: #inspectIt) 
		category: #SmalltalkEditor;
		shortcutName: #inspectIt;
		label: 'inspect it' translated;
 		description: 'editor shortcut to inspect a piece of code' translated.
		
	(aBuilder shortcut: #implementorsOfIt) 
		category: #SmalltalkEditor;
		shortcutName: #implementorsOfIt;
		label: 'implementors' translated;
 		description: 'editor shortcut to show a list of classes implementing a method named after the current selection' translated.
		
	(aBuilder shortcut: #sendersOfIt) 
		category: #SmalltalkEditor;
		shortcutName: #sendersOfIt;
		label: 'senders' translated;
 		description: 'editor shortcut to show a list of mtethods sending the currently selected selector' translated.

	(aBuilder shortcut: #printIt) 
		category: #SmalltalkEditor;
		shortcutName: #printIt;
		label: 'print it' translated;
 		description: 'editor shortcut to evaluate the current selection and print the result' translated.! !

!KMEditorsDefaultSettings class methodsFor: 'settings' stamp: 'GuillermoPolito 8/10/2012 06:37'!
buildTextEditorKeymapsOn: aBuilder
	<keymap>
		
	(aBuilder shortcut: #selectAll) 
		category: #TextEditor
		default: $a command
		do: [ :morph | morph handleEdit: [ morph selectAll ] ].
		
	(aBuilder shortcut: #copySelection) 
		category: #TextEditor
		default: $c command
		do: [ :morph | morph copySelection ].
		
	(aBuilder shortcut: #find) 
		category: #TextEditor
		default: $f command
		do: [ :morph | morph find ].
		
	(aBuilder shortcut: #findAgain) 
		category: #TextEditor
		default: $g command
		do: [ :morph | morph findAgain ].
		
	(aBuilder shortcut: #setSearchString)
		category: #TextEditor
		default: $h command
		do: [ :morph | morph setSearchString ].
		
	(aBuilder shortcut: #cancel) 
		category: #TextEditor
		default: $l command
		do: [ :morph | morph cancel ].
		
	(aBuilder shortcut: #paste) 
		category: #TextEditor
		default: $v command
		do: [ :morph | morph paste ].
		
	(aBuilder shortcut: #cut) 
		category: #TextEditor
		default: $x command
		do: [ :morph | morph cut ].
				
	(aBuilder shortcut: #undo) 
		category: #TextEditor
		default: $z command
		do: [ :morph | morph undo ].
		
	(aBuilder shortcut: #redo) 
		category: #TextEditor
		default: $z command shift
		do: [ :morph | morph redo ].
	
	(aBuilder shortcut: #cursorHome)
		category: #TextEditor
		default: Character home command
		do: [ :morph :target :evt | morph cursorHome: evt ].
	
	(aBuilder shortcut: #cursorEnd)
		category: #TextEditor
		default: Character end command
		do: [ :morph :target :evt | morph cursorEnd: evt ].
		
	(aBuilder shortcut: #removeLine)
		category: #TextEditor
		default: Character delete shift
		do: [ :morph | morph removeLine ].! !

!KMEditorsDefaultSettings class methodsFor: 'settings' stamp: 'DeboraFortini 12/13/2011 16:50'!
buildTextEditorMacOSKeymapsOn: aBuilder
	<keymap: #MacOSX>
	
	(aBuilder shortcut: #removeLine)
		category: #TextEditor
		default: Character backspace shift
		do: [ :morph | morph removeLine ].! !

!KMEditorsDefaultSettings class methodsFor: 'settings' stamp: 'GuillermoPolito 12/11/2011 03:14'!
buildTextEditorSettingsOn: aBuilder
		
	(aBuilder shortcut: #selectAll)
		shortcutName: #selectAll;
		category: #TextEditor;
		label: 'select all' translated;
 		description: 'editor shortcut to select all text' translated.
		
	(aBuilder shortcut: #copySelection) 
		category: #TextEditor;
		shortcutName: #copySelection;
		label: 'copy selection' translated;
 		description: 'editor shortcut to copy the selected text' translated.
		
	(aBuilder shortcut: #find) 
		category: #TextEditor;
		shortcutName: #find;
		label: 'find' translated;
 		description: 'editor shortcut to find text' translated.
		
	(aBuilder shortcut: #findAgain) 
		category: #TextEditor;
		shortcutName: #findAgain;
		label: 'find again' translated;
 		description: 'editor shortcut to find the next match' translated.
		
	(aBuilder shortcut: #setSearchString) 
		category: #TextEditor;
		shortcutName: #setSearchString;
		label: 'set search string' translated;
 		description: 'editor shortcut to set the search string to the currently selected text' translated.
		
	(aBuilder shortcut: #cancel) 
		category: #TextEditor;
		shortcutName: #cancel;
		label: 'cancel' translated;
 		description: 'editor shortcut to cancle the current changes' translated.
		
	(aBuilder shortcut: #paste) 
		category: #TextEditor;
		shortcutName: #paste;
		label: 'paste' translated;
 		description: 'editor shortcut to paste text' translated.
		
	(aBuilder shortcut: #cut) 
		category: #TextEditor;
		shortcutName: #cut;
		label: 'cut' translated;
 		description: 'editor shortcut to cut selected text' translated.

	(aBuilder shortcut: #undo) 
		category: #TextEditor;
		shortcutName: #undo;
		label: 'Undo' translated;
 		description: 'editor shortcut to undo changes' translated.
		
	(aBuilder shortcut: #redo)
		category: #TextEditor;
		shortcutName: #redo;
		label: 'Redo' translated;
 		description: 'editor shortcut to redo changes' translated.
		
	(aBuilder shortcut: #cursorHome) 
		category: #TextEditor;
		shortcutName: #cursorHome;
		label: 'Move cursor Home' translated;
 		description: 'editor shortcut to move cursor to the initial part of the document' translated.
		
	(aBuilder shortcut: #cursorEnd) 
		category: #TextEditor;
		shortcutName: #cursorEnd;
		label: 'Move cursor End' translated;
 		description: 'editor shortcut to move cursor to the final part of the document' translated.! !

!KMEditorsDefaultSettings class methodsFor: 'settings' stamp: 'CamilloBruni 3/12/2011 15:31'!
defaultSettingsOn: aBuilder  
	<systemsettings>	
	(aBuilder group: #Editors)
		label: 'Editors' translated;
		description: 'Editors shortcuts' translated;
		parent: #keymappings;
		with: [
			self buildSmalltalkEditorSettingsOn: aBuilder.
			self buildTextEditorSettingsOn: aBuilder.
		]! !

!SmalltalkEditor methodsFor: '*keymapping-editors' stamp: 'GuillermoPolito 12/11/2011 03:00'!
installKeymappingsOn: aMorph
	super installKeymappingsOn: aMorph.
	aMorph attachKeymapCategory: #SmalltalkEditor! !

!TextEditor methodsFor: '*keymapping-editors' stamp: 'GuillermoPolito 12/11/2011 03:00'!
installKeymappingsOn: aMorph
	aMorph attachKeymapCategory: #TextEditor! !

!TextEditor methodsFor: '*keymapping-editors' stamp: 'GuillermoPolito 10/20/2011 23:43'!
removeLine
	"this one really selects the line"
	self replace: (self encompassParagraph: self selectionInterval) with: '' asText and: [ ].
	^true! !

!PluggableTextMorph methodsFor: '*Keymapping-Editors-Override' stamp: 'DeboraFortini 12/13/2011 15:16'!
initializeKeymappings
	textMorph editor installKeymappingsOn: self.! !

!PluggableTextMorph methodsFor: '*Keymapping-Editors' stamp: 'GuillermoPolito 12/11/2011 03:35'!
removeLine
	self handleEdit: [ textMorph editor removeLine ].! !

!PluggableTextMorph methodsFor: '*Keymapping-Editors-Override' stamp: 'DeboraFortini 12/13/2011 16:43'!
setTextBasic: aText

	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph := self textMorphClass new
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph.
				self textMorph 
					autoAccept: self autoAccept;
					selectionColor: self selectionColor.
				self initializeKeymappings.
				]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !
